/** ###################################################################
**     Filename  : LEDVU2.C
**     Project   : LEDVU2
**     Processor : MC9S08GT60CB
**     Version   : Driver 01.11
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 06/12/2011, 04:48 p.m.
**     Abstract  :
**         Main module.
**         This module contains user's application code.
**     Settings  :
**     Contents  :
**         No public methods
**
** ###################################################################*/
/* MODULE LEDVU2 */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "TI1.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#define LED7  PTAD_PTAD7
#define LED7D PTADD_PTADD7

#define LEDS PTAD
#define LEDSD PTADD

unsigned int cnts[10];
unsigned long adcs;
unsigned char LedsOut;

float num;
unsigned int nument,nument_ant;
unsigned int leds;
byte arregloled;

byte peak;
byte TimeOutPeak;
unsigned int ADCValue;
unsigned int ADCValue_prom;


void ADCInit(unsigned char channel);
void ADCSetChannel(unsigned char channel);
unsigned int ADCGetValue(void);
void calcula_leds(unsigned int valor);
void ProcessLeds(void);
void ProcessADC(void);


void main(void)
{
  /* Write your local variable definition here */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  LEDSD = 0xFF;
  LEDS = 0x00;
  
  ADCInit(0);
  /* For example: for(;;) { } */
   for(;;) { 
      ProcessLeds();
      ProcessADC();
   }



  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END LEDVU2 */
/*
** ###################################################################
**
**     This file was created by Processor Expert 3.07 [04.34]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/




void ProcessLeds(void){

    if(cnts[0]==0){
      cnts[0] = 5;
      calcula_leds(ADCValue_prom);
    }
    if(cnts[1]==0 && (TimeOutPeak == 1)){
      cnts[1] = 150;
      if( leds > 0 ){
        leds = leds - 1;
      }
    }
    if(cnts[2] == 0){
       TimeOutPeak = 1;
    }
}

byte cuenta_falloff;

void calcula_leds(unsigned int valor){
  
        
        unsigned char i;
        
        num = ((float)8 / (float)512);
        num = (num * (float)valor);
        nument = (unsigned int)num;
        arregloled = 0;
        if(nument > 8){
          nument = 8;
        }
        //ojo fall down
        if(nument > nument_ant){
          nument_ant = nument;
          cuenta_falloff = 12;           
        }else if(cuenta_falloff == 0){
          cuenta_falloff = 12;
          if(nument_ant){
            nument_ant = (nument_ant - 1); 
          }
          nument = nument_ant;   
        }else{
          nument = nument_ant;
          cuenta_falloff--;
        }
    
        //***************
        for(i = 0; i < nument; i ++){
            arregloled = arregloled << 1;
            arregloled = arregloled | 1;
        }

        if( leds > nument){
            peak = 1;
            peak = peak << (leds - 1);
            arregloled = arregloled | peak;
        }

        if(nument > leds){
             leds = nument;
             TimeOutPeak = 0;
             cnts[2] = 1500;
        }
                
        LEDS = arregloled;
}


byte cont_muestras;

void ProcessADC(void){

      ADCValue = ADCGetValue();
      adcs += ADCValue;
      cont_muestras++;
      if(cont_muestras>=10){
         ADCValue_prom = (adcs/10);
         adcs = 0;
         cont_muestras = 0;        
      }
}

void ADCInit(unsigned char channel){


       ATD1PE = 0b00000001;
       ATD1C_ATDPU = 1;
       ATD1C_DJM = 1;
       ATD1C_RES8 = 0;
       ATD1C_SGN = 0;
       ATD1C_PRS = 0b0100;
       
       ATD1SC_ATDIE = 0;
       ATD1SC_ATDCO = 1;
       ATD1SC_ATDCH = channel;

}

void ADCSetChannel(unsigned char channel){

    ATD1SC_ATDCH = channel;

}

unsigned int ADCGetValue(void){

    //while(ATD1SC_CCF == 0);
    return ATD1R;
}
